"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
var index_1 = require("./index");
var defaultConfig_1 = __importDefault(require("./defaultConfig"));
var utils_1 = require("./utils");
var fs_1 = __importDefault(require("fs"));
var js_yaml_1 = __importDefault(require("js-yaml"));
var name = 'swaggerlint-core';
function cli() {
    return __awaiter(this, void 0, void 0, function () {
        var args, errors, config, configFlagIndex, url, urlFlagIndex, swagger, swaggerPath, pathFlagIndex, isYaml, swagger;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    args = process.argv;
                    errors = [];
                    config = defaultConfig_1["default"];
                    configFlagIndex = args.indexOf('--config');
                    if (configFlagIndex !== -1) {
                        // TODO validatie path
                        config = require(args[configFlagIndex + 1]);
                    }
                    url = null;
                    urlFlagIndex = args.indexOf('--url');
                    if (urlFlagIndex !== -1) {
                        url = args[urlFlagIndex + 1];
                    }
                    if (!url) return [3 /*break*/, 2];
                    utils_1.log("fetching for " + url);
                    return [4 /*yield*/, utils_1.fetchUrl(url)["catch"](function (e) {
                            console.warn('error fetching by URL');
                            utils_1.log("error fetching url, exiting...");
                            utils_1.log(e);
                            process.exit(1);
                        })];
                case 1:
                    swagger = _a.sent();
                    utils_1.log("got response");
                    errors = index_1.swaggerlint(swagger, config);
                    _a.label = 2;
                case 2:
                    swaggerPath = null;
                    pathFlagIndex = args.indexOf('--path');
                    if (pathFlagIndex !== -1) {
                        swaggerPath = args[pathFlagIndex + 1];
                    }
                    /**
                     * handling `swagger-lint --path /path/to/swagger.json`
                     */
                    if (swaggerPath) {
                        // non existing path
                        if (!fs_1["default"].existsSync(swaggerPath)) {
                            return [2 /*return*/, {
                                    code: 1,
                                    errors: [
                                        {
                                            msg: 'File with a provided path does not exits.',
                                            name: name
                                        },
                                    ]
                                }];
                        }
                        isYaml = utils_1.isYamlPath(swaggerPath);
                        swagger = isYaml
                            ? js_yaml_1["default"].safeLoad(fs_1["default"].readFileSync(swaggerPath, 'utf8'))
                            : require(swaggerPath);
                        errors = index_1.swaggerlint(swagger, config);
                    }
                    if (!(url || swaggerPath)) {
                        return [2 /*return*/, {
                                errors: [{
                                        name: name,
                                        msg: 'Neither url nor path were provided for your swagger scheme'
                                    }],
                                code: 1
                            }];
                    }
                    return [2 /*return*/, {
                            errors: errors,
                            code: errors.length ? 1 : 0
                        }];
            }
        });
    });
}
exports.cli = cli;
