"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
var rules_1 = __importDefault(require("./rules"));
function swaggerlint(swagger, lintConfig) {
    var errs = [];
    var checkRule = function (ruleName) {
        var check = rules_1["default"][ruleName];
        var ruleOptions = lintConfig.rules[ruleName];
        if (typeof check !== 'function') {
            console.warn("\"" + ruleName + "\" is not a valid rule name");
            process.exit(1);
        }
        errs = errs.concat(check(swagger, ruleOptions, lintConfig));
    };
    Object.keys(lintConfig.rules).forEach(checkRule);
    return errs;
}
exports.swaggerlint = swaggerlint;
