"use strict";
exports.__esModule = true;
var name = 'latin-definitions-only';
var rule = {
    name: name,
    check: function (swagger, _) {
        var errors = [];
        Object.keys(swagger.definitions).forEach(function (definition) {
            var rest = definition
                // def name may contain latin chars
                .replace(/[a-z]+/i, '')
                // or numerals
                .replace(/\d/gi, '');
            if (rest.length > 0) {
                errors.push({
                    msg: "Definition name \"" + definition + "\" contains non latin characters.",
                    name: name
                });
            }
        });
        return errors;
    }
};
exports["default"] = rule;
