"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
var lodash_1 = __importDefault(require("lodash"));
var name = 'properties-for-object-type';
var rule = {
    name: name,
    check: function (swagger, __, fullConfig) {
        var _a, _b, _c;
        var errors = [];
        lodash_1["default"].difference(Object.keys(swagger.definitions), (_c = (_b = (_a = fullConfig) === null || _a === void 0 ? void 0 : _a.ignore) === null || _b === void 0 ? void 0 : _b.definitions, (_c !== null && _c !== void 0 ? _c : []))).forEach(function (defKey) {
            var definition = swagger.definitions[defKey];
            if (definition.type === 'object') {
                if (!('properties' in definition)) {
                    errors.push({
                        msg: "\"" + defKey + "\" has \"object\" type but is missing \"properties\"",
                        name: name
                    });
                }
                else {
                    Object.keys(definition.properties).forEach(function (key) {
                        var topLevelProp = definition.properties[key];
                        if (topLevelProp.type === 'object' &&
                            !('properties' in topLevelProp)) {
                            errors.push({
                                msg: "Path \"" + defKey + "." + key + "\" is marked as \"object\" type but is missing \"properties\"",
                                name: name
                            });
                        }
                    });
                }
            }
        });
        return errors;
    }
};
exports["default"] = rule;
